/* Copyright (c) 2008, Sheng Guo, Li-San Wang and Junhyong Kim, University of
  Pennsylvania.  All Rights Reserved.
 
  You may not use this file except in compliance with the License
  located in the top directory of this distribution.  You may obtain
  a copy of the License at
 
      http://kim.bio.upenn.edu/software/index.shtml
 
  Unless required by applicable law or agreed to in writing, this
  software is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied.  See the License
  for the specific language governing permissions and limitations
  under the License. 
*/

#include "EvolutionTree.h"

using namespace std;

EvolutionTree::EvolutionTree(RootedTree * t){	tree = t;	}

EvolutionTree::~EvolutionTree(){
	//reclaim memory for map
	map<RootedTreeNode *, RNAWithPairing *>::iterator iter;
	for( iter= objlist.begin(); iter != objlist.end(); ++iter) {	
		if(iter->second != NULL){
			delete iter->second;			
			iter->second=NULL;
		}
		delete iter->first;
	}	
	//cout<<"EvolutionTree destructor called"<<endl;
}

void EvolutionTree::setrootobj( RNAWithPairing * obj){
	objlist[tree->getRoot()] = obj;
}

RootedTree * EvolutionTree::getTree() const{	
	return tree;
}

/*Erase Obj associated with a tree node */
void EvolutionTree::eraseObj(RootedTreeNode * x){
	
	map<RootedTreeNode *, RNAWithPairing *>::iterator iter = objlist.find(x);      
	if( iter != objlist.end() ){
		delete iter->second;
		iter->second=NULL;
	}
	else{
		cerr<<"Fatal error at file "<<__FILE__<<" line "<<__LINE__
		<<" : in map<RootedTreeNode *, RNAWithPairing *> "
		<<iter->first<<" has no corresponding value"<<endl; 
		exit(1);
	}
}


//END_OF_FILE
