/* Copyright (c) 2008, Sheng Guo, Li-San Wang and Junhyong Kim, University of
  Pennsylvania.  All Rights Reserved.
 
  You may not use this file except in compliance with the License
  located in the top directory of this distribution.  You may obtain
  a copy of the License at
 
      http://kim.bio.upenn.edu/software/index.shtml
 
  Unless required by applicable law or agreed to in writing, this
  software is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied.  See the License
  for the specific language governing permissions and limitations
  under the License. 
*/


#ifndef MUTATEONTREE_H
#define MUTATEONTREE_H

#include "RNAWithPairingEvolModel.h"
#include "EvolutionTree.h"
#include "Utility.h"


#include <string>
#include <vector>
#include <stack>
#include <map>
#include <fstream>
#include <iostream>


/****************************************************************************************

  class MutateOnTree: performs mutation along the evolutionary tree

****************************************************************************************/
class MutateOnTree{
	
	friend class EvolutionTree;
	
public:
	
	MutateOnTree(EvolutionTree * evt, RNAWithPairingEvolModel * m, RNAWithPairing * obj, bool verbose);
	void mutate(const char *, const char *, const char *, const char *, const char *, bool verboseflag=false);	
	
	/*these four functions are not used*/
	EvolutionTree * get_evtree() const;
	void set_evtree(EvolutionTree * evtree);	
	RNAWithPairingEvolModel * get_evmodel() const;
	void set_evmodel(RNAWithPairingEvolModel * model);

private:
	
	EvolutionTree * evtree;	
	RNAWithPairingEvolModel * model;
	bool verbose;

	void _mutate_on_edge(RootedTreeNode * child, bool verboseflag, int count);


};


#endif
